<?php
defined('BASEPATH') or exit('No direct script access allowed');

class AccountRegisteration extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->model('AccountingRegisterationModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Groups
    public function getAccountings()
    {
        $token = $this->tokenmiddleware->main();
       // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $accountings = $this->AccountingRegisterationModel->getAccountings();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الحسابات',
                'token' => $token,
                'data' => $accountings,
                'isAuth' => true,
                'total' => $this->AccountingRegisterationModel->count_records()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
    public function getTypes()
    {
        $token = $this->tokenmiddleware->main();

        $types = $this->AccountingRegisterationModel->getTypes();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الأنواع',
                'token' => $token,
                'data' => $types,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getAccount()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $Announce = $this->AccountingRegisterationModel->getAccount($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض حساب',
                'token' => $token,
                'data' => $Announce,
                'isAuth' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function createAccount()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->jwtmiddleware->createHash();
        $account = $this->input->post('account');
        $amount = $this->input->post('amount');
        $date = $this->input->post('date');
        $attachment = $this->input->post('attachment');
        $note = $this->input->post('note');
        $type = $this->input->post('type');
        
        $data = array(
            'hash'=>$hash,
            'account'=> $account,
            'amount' => $type == 2?  $amount * -1 : $amount,
            'date' => $date,
            'attachment' => $attachment,
            'note' =>$note,
            'type' =>$type,

        );
        $account = $this->AccountingRegisterationModel->createAccount($data);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم اضافة الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'data'=> $account
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function updateAccount()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $account = $this->input->post('account');
        $hash = $this->input->post('hash');
        $amount = $this->input->post('amount');
        $date = $this->input->post('date');
        $attachment = $this->input->post('attachment');
        $note = $this->input->post('note');
        $type = $this->input->post('type');
        
        $data = array(
            'hash'=>$hash,
            'account'=> $account,
            'amount' => $amount,
            'date' => $date,
            'attachment' => $attachment,
            'note' =>$note,
            'type' =>$type,
        );
        
        $accountRes = $this->AccountingRegisterationModel->updateAccount($data);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تعديل الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'data'=> $accountRes
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function deleteAccount()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $this->AccountingRegisterationModel->deleteAccount($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

}