<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Bank extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->model('BankModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Groups
    public function getAll()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $Bank = $this->BankModel->getAllBanks();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الحسابات',
                'token' => $token,
                'data' => $Bank,
                'isAuth' => true,
                'total' => $this->BankModel->count_records()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
    public function getAll_select()
    {
        $token = $this->tokenmiddleware->main();
        $Bank = $this->BankModel->getAll_select();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الحسابات',
                'token' => $token,
                'data' => $Bank,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
    
    public function get()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $Announce = $this->BankModel->getBank($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض حساب',
                'token' => $token,
                'data' => $Announce,
                'isAuth' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function create()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->jwtmiddleware->createHash();
        $currency = $this->input->post('currency');
        $name = $this->input->post('name');
        $amount = $this->input->post('amount');
        $date = $this->input->post('date');
        $note = $this->input->post('notes');
        $attachment = $this->input->post('attachment');

        $data = array(
            'hash'=>$hash,
            'name'=> $name,
            'amount' => $amount,
            'date' => $date,
            'attachment' => $attachment,
            'notes' =>$note,
            'currency' =>$currency,
        );
        $Bank = $this->BankModel->createBank($data);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم اضافة الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'data'=> $Bank
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function update()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);


        $hash = $this->input->post('hash');
        $currency = $this->input->post('currency');
        $name = $this->input->post('name');
        $amount = $this->input->post('amount');
        $date = $this->input->post('date');
        $note = $this->input->post('notes');
        $attachment = $this->input->post('attachment');

        $data = array(
            'hash'=>$hash,
            'name'=> $name,
            'amount' => $amount,
            'date' => $date,
            'attachment' => $attachment,
            'notes' =>$note,
            'currency' =>$currency,
        );

        $BankRes = $this->BankModel->updateBank($data);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تعديل الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'data'=> $BankRes
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function delete()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $this->BankModel->deleteBank($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

}