<?php

defined('BASEPATH') or exit('No direct script access allowed');

class CronTestController extends CI_Controller
{
    public function __construct()
    {
        parent::__construct();
        $this->load->model('FingerPrintSchedulerModel');
        $this->load->model('EmployeesWorkedHoursModel');
    }

    public function runCronJob()
    {

        $pendingWorkedHoursRecords = $this->FingerPrintSchedulerModel->get_pending_worked_hours_records();

        // this works for scheduled fingerPrints fine
        foreach ($pendingWorkedHoursRecords as $record) {
            $date = $record->date;
            $userHash = $record->user_hash;

            $this->EmployeesWorkedHoursModel->processEmployeeData($date, $date, $userHash);

            echo "Processing worked hours for record ID: " . $record->user_hash . "\n";
        }

        // Retrieve pending missed out fingerprints
        $pendingMissedOutFingerprints = $this->FingerPrintSchedulerModel->get_pending_missed_out_fingerprint();

        // Process pending missed out fingerprints
        foreach ($pendingMissedOutFingerprints as $record) {
            // Your logic to process each record
            // For example, update the status to missed
            echo "Processing missed out fingerprint for record ID: " . $record->id . "\n";
        }

        echo "Cron job executed successfully!";
    }

}
