<?php
defined('BASEPATH') or exit('No direct script access allowed');

class GlobalRebort extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->model('GlobalRebortModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
        echo 'GlobalRebort';
    }

    // get all Groups
    public function getGlobal()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $result = $this->GlobalRebortModel->get_all();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض التقرير العام بنجاح',
                'token' => $token,
                'data' => $result,
                'isAuth' => true,
                'total' => 10,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function chartPie()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $result = $this->GlobalRebortModel->chartPie();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض الاحصائيات بنجاح',
                'token' => $token,
                'data' => $result,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getEmployeesByStatus()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $status = $this->input->get('status');

        $result = $this->GlobalRebortModel->getEmployeesByStatus($status);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض التقرير العام بنجاح',
                'token' => $token,
                'data' => $result,
                'isAuth' => true,
            )
        );
        exit();
    }
}
