<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Notification extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->model('NotificationModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Offices
    public function count()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $data = $this->NotificationModel->count();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض الاشعارات',
                'token' => $token,
                'data' => $data,
                'action' => false,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }


    public function getNotifications()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $data = $this->NotificationModel->getNotifications();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض الاشعارات',
                'token' => $token,
                'data' => $data,
                'action' => false,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function deleteNotification()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $id = $this->input->post('id');
        $data = $this->NotificationModel->deleteNotification($id);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'حذف الاشعار',
                'token' => $token,
                'data' => $data,
                'action' => false,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function deleteAllNotification()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $data = $this->NotificationModel->deleteAllNotification();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'حذف الاشعارات',
                'token' => $token,
                'data' => $data,
                'action' => false,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
}