<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Offices extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->model('OfficesModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Offices
    public function getOffices()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $Offices = $this->OfficesModel->getOffices();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الاماكن',
                'token' => $token,
                'data' => $Offices,
                'isAuth' => true,
                'total' => $this->OfficesModel->count_records(),
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getOffice()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('id');
        $Office = $this->OfficesModel->getOffice($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الاماكن',
                'token' => $token,
                'data' => $Office,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }


    public function createOffice()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $data = array(
            'hash' => $this->jwtmiddleware->createHash(),
            'name' => $this->input->post('name'),
            'address' => $this->input->post('address'),
            'allow_merters' => $this->input->post('allow_merters'),
            'x' => $this->input->post('x'),
            'y' => $this->input->post('y'),
        );
        $this->OfficesModel->insertOffice($data);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم اضافة الموقع بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function updateOffice()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $data = array(
            'name' => $this->input->post('name'),
            'hash' => $this->input->post('hash'),
            'address' => $this->input->post('address'),
            'allow_merters' => $this->input->post('allow_merters'),
            'x' => $this->input->post('x'),
            'y' => $this->input->post('y'),
        );
        $this->OfficesModel->updateOffice($data, $hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تعديل الموقع بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function deleteOffice()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $this->OfficesModel->deleteOffice($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف الموقع بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
}