<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Partments extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->model('PartmentsModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Partments
    public function getPartments()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $Partments = $this->PartmentsModel->getPartments();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الموظفين',
                'token' => $token,
                'data' => $Partments,
                'isAuth' => true,
                'total' => $this->PartmentsModel->count_records()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getPart()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('id');
        $Part = $this->PartmentsModel->getPart($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الاماكن',
                'token' => $token,
                'data' => $Part,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }


    public function createPart()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $data = array(
            'hash' => $this->jwtmiddleware->createHash(),
            'name' => $this->input->post('name')
        );
        $this->PartmentsModel->insertPart($data);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم اضافة الموقع بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function updatePart()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $data = array(
            'name' => $this->input->post('name'),
            'hash' => $this->input->post('hash'),
        );
        $this->PartmentsModel->updatePart($data, $hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تعديل الموقع بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function deletePart()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $this->PartmentsModel->deletePart($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف الموقع بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getUsersByPart()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $hash = $this->input->get('hash');
        if (!$hash) {
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'يجب ادخال رمز القسم',
                    'token' => $token,
                    'isAuth' => true
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }

        $users = $this->PartmentsModel->getUsersByPart($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض الموظفين',
                'token' => $token,
                'data' => $users,
                'isAuth' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
}