<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Reports extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->model('ReportModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Report
    public function getLateReports()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $Report = $this->ReportModel->getLateReport();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الموظفين',
                'token' => $token,
                'data' => $Report,
                'isAuth' => true,
                'total' => $this->ReportModel->get_late_records(),
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getStayReports()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $Report = $this->ReportModel->getStayReport();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الموظفين',
                'token' => $token,
                'data' => $Report,
                'isAuth' => true,
                'total' => $this->ReportModel->get_stay_records(),
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getNotPhoneReports()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $Report = $this->ReportModel->getNotPhoneReport();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الموظفين',
                'token' => $token,
                'data' => $Report,
                'isAuth' => true,
                'total' => $this->ReportModel->get_not_phone_records(),
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function salary()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $Report = $this->ReportModel->get_salary_records();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض التقرير المالي',
                'token' => $token,
                'data' => $Report['result'],
                'isAuth' => true,
                'total' => $Report['count'],
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function get_daily_records()
    {
        $this->UserModel->checkPermission();
        $user_hash = $this->input->post('user_hash');
        $start_date = $this->input->post('start_date');
        $end_date = $this->input->post('end_date');

        if (empty($user_hash) || empty($start_date) || empty($end_date)) {
            return $this->output
                ->set_content_type('application/json')
                ->set_status_header(400)
                ->set_output(json_encode(['error' => 'Missing required parameters']));
        }

        $result = $this->ReportModel->get_daily_records($user_hash, $start_date, $end_date);

        return $this->output
            ->set_content_type('application/json')
            ->set_output(json_encode($result));
    }

    public function todayReport()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $search = $this->input->post('search');
        $Report = $this->ReportModel->get_today_report($search);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض التقرير اليومي',
                'token' => $token,
                'data' => $Report,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    //deleteNotPhone
    public function updateStatusInNotPhone()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $id = $this->input->post('hash');
        $this->ReportModel->updateStatusInNotPhone($id);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تحديث الحالة',
                'token' => $token,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getFingerPrintLog()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $start_date = $this->input->post('start_date');
        $end_date = $this->input->post('end_date');
        $employee_name = $this->input->post('q');
        $Report = $this->ReportModel->getFingerprintLog($start_date, $end_date, $employee_name);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض تقرير البصمات ',
                'token' => $token,
                'data' => $Report,
                'isAuth' => true,
                'total' => $this->ReportModel->countFingerprintLog($start_date, $end_date, $employee_name),
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function editFingerPrint()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

    }

    public function deleteFingerPrint()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $res = $this->ReportModel->deleteFingerprintLog($hash);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف البصمة بنجاح',
                'token' => $token,
                'data' => $res,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();

    }
}
