<?php
defined('BASEPATH') or exit('No direct script access allowed');
class Specifaction extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->model('SpecifactionModel');
        $this->load->model('PositionOtherModel');

        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }
    public function getSpecifications()
    {

        $this->UserModel->checkPermission();

        $data = $this->SpecifactionModel->getSpecifactions();

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'Specifications successfully retrieved',
                'data' => $data,
                'total' => $this->SpecifactionModel->count_records()
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'No specifications found',
                'data' => [],
                'total' => $this->SpecifactionModel->count_records()
            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function getOtherSpecifications()
    {
        $this->UserModel->checkPermission();

        $data = $this->SpecifactionModel->getOtherSpecifications();

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'otherSpecifications successfully retrieved',
                'data' => $data,
                'total' => $this->SpecifactionModel->count_other_specifications()
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'No otherspecifications found',
                'total' => $this->SpecifactionModel->count_other_specifications()
            );
            $this->output->set_output(json_encode($response));
        }
    }
    public function getSpecificationsSelect()
    {
        $this->UserModel->checkPermission();

        $data = $this->SpecifactionModel->getSpecifactionsSelect();

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'Specifications successfully retrieved in select format',
                'data' => $data
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'No specifications found in select format',
            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function getSpecificationsTypes()
    {
        $this->UserModel->checkPermission();

        $data = $this->SpecifactionModel->getSpecifactionsTypes();

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'Specification types successfully retrieved',
                'data' => $data
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'No specification types found',
            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function getSpecification()
    {
        $this->UserModel->checkPermission();

        $id = $this->input->get("id");

        $data = $this->SpecifactionModel->getSpecifaction($id);

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'Specification successfully retrieved',
                'data' => $data
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'Specification not found',
            );
            $this->output->set_output(json_encode($response));
        }
    }

    // This for a test now
    public function getSpecificationById()
    {
        $this->UserModel->checkPermission();

        $specificationsId = $this->input->get("id");

        $data = $this->SpecifactionModel->getDataBySpecificationsId($specificationsId);

        if (!empty($data)) {
            // Rename the 'id' key to 'specificationsId' in the $data array

            $data_array = array();

            foreach ($data as $item) {
                $item_array = array();

                foreach ($item as $key => $value) {
                    // Rename keys if needed
                    if ($specificationsId == 2) {
                        if ($key == 'ID') {
                            $key = 'id';
                        } elseif ($key == 'Name') {
                            $key = 'name';
                        }
                    }

                    $item_array[$key] = $value;
                }

                $data_array[] = $item_array;
            }

            $response = array(
                'status' => 200,
                'message' => 'Specification successfully retrieved',
                'data' => $data_array
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'Specification not found',
            );
            $this->output->set_output(json_encode($response));
        }
    }
    public function getOtherSpecificationById()
    {
        $this->UserModel->checkPermission();

        $otherSpecificationsId = $this->input->get("id");

        $data = $this->SpecifactionModel->getOtherSpecificationById($otherSpecificationsId);

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'otherSpecification successfully retrieved',
                'data' => $data
            );

            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'Otherspecification not found',
                'data' => [],
            );

            $this->output->set_output(json_encode($response));
        }
    }

    public function getDataByType()
    {
        $this->UserModel->checkPermission();

        $tableName = $this->input->get("table_name");

        $data = $this->SpecifactionModel->getDataByType($tableName);

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'Data successfully retrieved by type',
                'data' => $data
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'Data not found by type',
            );
            $this->output->set_output(json_encode($response));
        }
    }

    // TEST
    public function someMethod()
    {
        $userId = '223344554332';
        ; // Replace with the actual user ID
        $jsonResult = $this->SpecifactionModel->getUserSpecifications($userId);
        // Pass $data to your view
        $this->output->set_content_type('application/json')->set_output($jsonResult);

    }


    // This used in insert don't touch plz before talk to me
    //  its very critical (youssef)
    public function getCurrentUserSpecifications()
    {
        $this->UserModel->checkPermission();


        $user_id = $this->input->get("emp_id");


        $data = $this->SpecifactionModel->getCurrentUserSpecifications($user_id);

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'success get data',
                'data' => $data,
                'action' => 'false'
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 200,
                'message' => 'null',
                'data' => [],
                'action' => 'false'
            );
            $this->output->set_output(json_encode($response));
        }
    }
    public function getCurrentUserTypesSpecifications()
    {
        $this->UserModel->checkPermission();


        $user_id = $this->input->get("emp_id");


        $data = $this->SpecifactionModel->getCurrentUserTypesSpecifications($user_id);

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'success get data',
                'data' => $data,
                'action' => 'false'
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 200,
                'message' => 'null',
                'data' => [],
                'action' => 'false'
            );
            $this->output->set_output(json_encode($response));
        }
    }
    public function getCurrentUserSpecificationsSelect()
    {
        $this->UserModel->checkPermission();


        $user_id = $this->input->get("emp_id");


        $data = $this->SpecifactionModel->getCurrentUserSpecificationsSelect($user_id);

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'success get data',
                'data' => $data,
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 200,
                'message' => 'null',
                'data' => [],
            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function insertUserSpecification()
    {
        $this->UserModel->checkPermission();
        $user_id = $this->input->post("emp_id");
        $specification_id = $this->input->post("specification_id");

        $data = array(
            'emp_info_id' => $user_id,
            'specification_id' => $specification_id
        );
        $result = $this->SpecifactionModel->insertUserSpecification($data);
        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'success insert UserSpecification',
                'action' => 'true'
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 500,
                'message' => 'failed insert UserSpecification',
                'action' => 'true'
            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function deleteUserSpecification()
    {
        $this->UserModel->checkPermission();
        $user_id = $this->input->post("emp_id");
        $specification_id = $this->input->post("specification_id");
        $result = $this->SpecifactionModel->deleteUserSpecification($user_id, $specification_id);
        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'success delete UserSpecification',
                'action' => 'true'
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 200,
                'message' => 'failed delete UserSpecification',
                'action' => 'true'
            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function updateUserSepcification()
    {
        $this->UserModel->checkPermission();

        // Assuming you have similar input validation for the update as well

        $user_id = $this->input->post("emp_id");
        $specifications_array = $this->input->post('specifications_array'); // this should be array

        if ($user_id && !$specifications_array) {
            $this->SpecifactionModel->deletAllSpecificationForUser($user_id);

        }
        if (!$user_id || !is_array($specifications_array) || empty($specifications_array)) {
            return $this->sendResponse(400, 'تم ادخال بيانات خاطئه لمخخصات', true);
        }


        $this->db->trans_start();


        try {
            $currentUserSpecifications = $this->SpecifactionModel->getCurrentUserSpecifications($user_id);

            $currentUserSpecifications = is_array($currentUserSpecifications) ? $currentUserSpecifications : [];
            $specifications_array = is_array($specifications_array) ? $specifications_array : [];
            $toDelete = array_diff($currentUserSpecifications, $specifications_array);
            foreach ($toDelete as $specification_id) {
                $this->SpecifactionModel->deleteUserSpecification($user_id, $specification_id);
            }

            $toInsert = array_diff($specifications_array, $currentUserSpecifications);
            foreach ($toInsert as $specification_id) {
                $user_specificationsData = [
                    'emp_info_id' => $user_id,
                    'specification_id' => $specification_id
                ];
                $this->SpecifactionModel->insertUserSpecification($user_specificationsData);
            }

            $this->db->trans_complete();

            // Check the status of the transaction
            if ($this->db->trans_status() === FALSE) {
                $this->sendResponse(500, 'Transaction failed', false);
            } else {
                $this->sendResponse(200, 'تم تعديل المخصصات بنجاح', false);
            }
        } catch (Exception $e) {
            $this->db->trans_rollback();
            $this->sendResponse(500, 'Exception: ' . $e->getMessage(), false);
        }
    }

    // public function insertSpecifactions()
    // {
    //     $this->UserModel->checkPermission();

    //     $data = $this->input->post();


    //     $result = $this->SpecifactionModel->insertSpecifactions($data);

    //     if ($result) {
    //         $response = array(
    //             'status' => 200,
    //             'message' => 'تم إدراج المخصصات بنجاح',
    //             'action' => 'true'
    //         );
    //         $this->output->set_output(json_encode($response));
    //     } else {
    //         $response = array(
    //             'status' => 500,
    //             'message' => 'Failed to insert specifications',
    //             'action' => 'true'
    //         );
    //         $this->output->set_output(json_encode($response));
    //     }
    // }

    public function insertSpecifactions()
    {
        $this->UserModel->checkPermission();

        $data = $this->input->post();

        $result = $this->SpecifactionModel->insertSpecifactions($data);

        $this->output->set_output(json_encode($result));
    }

    public function insertOtherSpecifications()
    {
        $this->UserModel->checkPermission();

        $data = $this->input->post();


        $result = $this->SpecifactionModel->insertOtherSpecifications($data);

        if (is_string($result) && !empty($result)) {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => $result,
                    'token' => null,
                    'data' => null,
                    'isAuth' => false,
                    'action' => false,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }

        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'تم إدراج مخخصات اخره بنجاح',
                'action' => 'true'
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 500,
                'message' => 'فشل الادخال الرجاء المحاوله مره اخري',
                'action' => 'true'
            );
            $this->output->set_output(json_encode($response));
        }
    }


    public function updateSpecifactions()
    {
        $this->UserModel->checkPermission();

        $data = $this->input->post();

        if (empty($data['id'])) {
            $response = array(
                'status' => 400, // Use an appropriate HTTP status code for a bad request
                'message' => 'ID not provided for the update operation',
            );

            $this->output->set_output(json_encode($response));
            return;
        }
        $result = $this->SpecifactionModel->updateSpecifactions($data);

        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'تم تحديث المخصصات بنجاح',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 500,
                'message' => 'فشل في تحديث المخصصات',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        }
    }
    public function updateOtherSpecifications()
    {
        $this->UserModel->checkPermission();

        $data = $this->input->post();

        if (empty($data['id'])) {
            $response = array(
                'status' => 400, // Use an appropriate HTTP status code for a bad request
                'message' => 'ID not provided for the update operation',
            );

            $this->output->set_output(json_encode($response));
            return;
        }
        $result = $this->SpecifactionModel->updateOtherSpecifications($data);

        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'تم تحديث المخصصات بنجاح اخري',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 500,
                'message' => ' فشل في تحديث المخصصات اخري',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function deleteSpecification()
    {
        $this->UserModel->checkPermission();

        $id = $this->input->post("id");

        $result = $this->SpecifactionModel->deleteSpecification($id);

        if ($result === true) {
            $response = array(
                'status' => 200,
                'message' => 'تم حذف المخصص بنجاح',
                'action' => 'true'
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 400,
                'message' => $result,
                'action' => 'false'

            );
            $this->output->set_output(json_encode($response));
        }
    }


    public function deleteOtherSpecifications()
    {
        $this->UserModel->checkPermission();

        $id = $this->input->post("id");

        $result = $this->SpecifactionModel->deleteOtherSpecifications($id);

        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'تم حذف المخصص اخر بنجاح',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 500,
                'message' => 'فشل في حذف  المخصص',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function getPositionspecifications()
    {
        $this->UserModel->checkPermission();

        $data = $this->PositionOtherModel->get();

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'positionSpecifications successfully retrieved',
                'data' => $data,
                'total' => $this->PositionOtherModel->count_records()
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'No positionSpecificationsspecifications found',
                'data' => [],
                'total' => $this->PositionOtherModel->count_records()
            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function getPositionsSpecificationById()
    {
        $this->UserModel->checkPermission();

        $positionSpecificationsId = $this->input->get("id");

        $data = $this->PositionOtherModel->getById($positionSpecificationsId);

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'positionSpecification successfully retrieved',
                'data' => $data
            );

            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'positionSpecification not found',
                'data' => [],
            );

            $this->output->set_output(json_encode($response));
        }
    }



    public function insertSpecificationPosition()
    {
        $this->UserModel->checkPermission();
        $data = $this->input->post();
        $result = $this->PositionOtherModel->insert($data);

        if (is_string($result) && !empty($result)) {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => $result,
                    'token' => null,
                    'data' => null,
                    'isAuth' => false,
                    'action' => false,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }



        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'تم إدراج مخخص المنصب بنجاح',
                'action' => 'true',
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 500,
                'message' => 'فشل الادخال الرجاء المحاوله مره اخري',
                'action' => 'true'
            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function updateSpecificationPosition()
    {
        $this->UserModel->checkPermission();

        $data = $this->input->post();

        if (empty($data['id'])) {
            $response = array(
                'status' => 400, // Use an appropriate HTTP status code for a bad request
                'message' => 'ID not provided for the update operation',
            );

            $this->output->set_output(json_encode($response));
            return;
        }
        $result = $this->PositionOtherModel->update($data);

        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'تم تحديث مخصص المنصب بنجاح اخري',
                'action' => 'true'

            );

            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 500,
                'message' => ' فشل في تحديث المخصصات اخري',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function deleteSpecificationPosition()
    {
        $this->UserModel->checkPermission();

        $id = $this->input->post("id");

        $result = $this->PositionOtherModel->delete($id);

        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'تم حذف مخصص المنصب بنجاح',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 500,
                'message' => 'فشل في حذف المخصص',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        }
    }


    private function sendResponse($status, $message, $action = true, $total = null)
    {
        $response = array('status' => $status, 'message' => $message, 'action' => $action, 'total' => $total);
        $this->output->set_output(json_encode($response));
    }

}