<?php
defined('BASEPATH') or exit('No direct script access allowed');

class SubAccount extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->model('SubAccountModel');
        $this->load->model('AccountingRegisterationModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Groups
    public function getAll()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $Bank = $this->SubAccountModel->getAllSubAccounts();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الحسابات',
                'token' => $token,
                'data' => $Bank,
                'isAuth' => true,
                'total' => $this->SubAccountModel->count_records()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
    public function getAll_select()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $Bank = $this->SubAccountModel->getAll_select();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الحسابات',
                'token' => $token,
                'data' => $Bank,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function get()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $Announce = $this->SubAccountModel->getSubAccount($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض حساب',
                'token' => $token,
                'data' => $Announce,
                'isAuth' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function create()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->jwtmiddleware->createHash();
        $name = $this->input->post('name');
        $number = $this->input->post('number');

        $data = array(
            'hash'=>$hash,
            'name'=> $name,
            'number'=> $number,
            'account_id'=>111271
        );
        $Bank = $this->SubAccountModel->createSubAccount($data);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم اضافة الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'data'=> $Bank
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function update()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);


        $hash = $this->input->post('hash');
        $name = $this->input->post('name');
        $number = $this->input->post('number');

        $data = array(
            'hash'=>$hash,
            'name'=> $name,
            'number'=> $number
        );

        $BankRes = $this->SubAccountModel->updatesubaccount($data);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تعديل الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'data'=> $BankRes
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function delete()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $this->SubAccountModel->deleteSubAccount($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
    public function addExpenses()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $BankHash = $this->jwtmiddleware->createHash();
        $note = $this->input->post('note');
        $expenseHash = $this->jwtmiddleware->createHash();

        $BankAccount = $this->input->post('bank');
        $BankAmount = ($this->input->post('amount') * -1);
        $BankType = 2;
        $BankData = array(
            'hash'=>$BankHash,
            'account_name'=> $BankAccount,
            'amount' => $BankAmount,
            'note' =>$note,
            'type' =>$BankType,
        );
        $BankAccountResponse = $this->AccountingRegisterationModel->createAccount($BankData);

        $expenseAccount = $this->input->post('expense');
        $expenseAmount = $this->input->post('amount');
        $expenseType = 1;
        $expenseData = array(
            'hash'=>$expenseHash,
            'account_name'=> $expenseAccount,
            'amount' => $expenseAmount,
            'note' =>$note,
            'type' =>$expenseType,
        );
        $ExpenseAccountResponse = $this->AccountingRegisterationModel->createAccount($expenseData);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تسجيل التحويلة المالية بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'expense_response' =>$ExpenseAccountResponse,
                'bank_response' =>$BankAccountResponse
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

}