<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Upload extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->helper(array('form', 'url'));
        $this->load->library('upload');
        $this->load->library('Middleware');
    }

    

    private function RandomString()
    {
        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $randstring = '';
        for ($i = 0; $i < 10; $i++) {
            $randstring .= $characters[rand(0, strlen($characters) - 1)];
        }
        return $randstring;
    }


    public function uploadSingle()
    {
        $folder_location = $this->input->post('folder_location');
        $is_scanner_required = $this->input->post('is_scanner');
        $is_book = $this->input->post('is_book');
        $is_export = $this->input->post('is_export');
        $book_name = $this->input->post('book_name');


        if (isset($_FILES['file'])) {
            $file = $_FILES['file'];

            if ($file['error'] === UPLOAD_ERR_OK) {
                if (isset($book_name)) {
                    $filename = $book_name . '.pdf' ?? $file['name'];

                } else {
                    $filename = $file['name'];
                }
                $temp_path = $file['tmp_name'];

                if (!empty($folder_location)) {
                    $target_path = 'uploads/' . $folder_location . '/' . $filename;
                    if (!is_dir('uploads/' . $folder_location)) {
                        mkdir('uploads/' . $folder_location, 0777, true);
                    }
                } else {
                    $target_path = 'uploads/' . $filename;

                    if ($is_book == 1) {
                        $currentYear = date('Y');
                        $currentMonth = date('m');
                        $uploadDir = 'uploads/' . $currentYear . '/' . $currentMonth . '/';

                        if ($is_export == 1) {
                            $uploadDir = $uploadDir . 'export/';

                            if (!is_dir($uploadDir)) {
                                mkdir($uploadDir, 0777, true);
                            }

                            $target_path = $uploadDir . $filename;
                        } else {
                            $uploadDir = $uploadDir . 'import/';

                            if (!is_dir($uploadDir)) {
                                mkdir($uploadDir, 0777, true);
                            }

                            $target_path = $uploadDir . $filename;
                        }

                        if (!is_dir($uploadDir)) {
                            mkdir($uploadDir, 0777, true);
                        }
                    }

                    if (!is_dir('uploads')) {
                        mkdir('uploads', 0777, true);
                    }
                }


                $randomStr = $this->RandomString();
                $fileType = strtolower(pathinfo($target_path, PATHINFO_EXTENSION));

                $target_path = preg_replace('/\.[^\.]*$/', '', $target_path);
                $fileNameWithoutExtension = pathinfo($target_path, PATHINFO_FILENAME);
                $newFileName = $randomStr . time() . "_" . $fileNameWithoutExtension . "." . $fileType;
                // Remove the first occurrence of ".jpg" or any dot before the end of the line


                if (move_uploaded_file($temp_path, $target_path . $newFileName)) {
                    $full_path = base_url() . $target_path . $newFileName;
                    // system("/var/doc/py/run.sh ".$target_path." ".$book_name);
                    if ($is_scanner_required == 1) {
                        $socket_response = $this->scanner_file('Success');
                    }

                    echo json_encode(
                        array(
                            'status' => 200,
                            'message' => 'تم رفع الملف بنجاح',
                            'data' => $full_path,
                            'isAuth' => true,
                            'action' => true,
                        ),
                        JSON_UNESCAPED_UNICODE
                    );
                } else {
                    // Error occurred while moving the uploaded file
                    echo json_encode(
                        array(
                            'status' => 200,
                            'message' => 'حدث خطأ أثناء رفع الملف',
                            'isAuth' => true
                        ),
                        JSON_UNESCAPED_UNICODE
                    );
                }
            } else {
                // Error occurred while uploading the file
                echo json_encode(
                    array(
                        'status' => 200,
                        'message' => 'حدث خطأ أثناء رفع الملف',
                        'isAuth' => true
                    ),
                    JSON_UNESCAPED_UNICODE
                );
            }
        } else {
            // No file was uploaded
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء رفع الملف',
                    'isAuth' => true
                ),
                JSON_UNESCAPED_UNICODE
            );
        }
    }


    public function uploadMulti()
    {
        if (isset($_FILES['files'])) {
            $files = $_FILES['files'];
            $count = count($files['name']);
            $all_path = array();

            for ($i = 0; $i < $count; $i++) {
                $filename = $files['name'][$i];
                $temp_path = $files['tmp_name'][$i];
                $target_dir = 'uploads/';
                $randomStr = $this->RandomString();
                $fileType = strtolower(pathinfo($filename, PATHINFO_EXTENSION));

                // Construct new filename
                $fileNameWithoutExtension = pathinfo($filename, PATHINFO_FILENAME);
                $newFileName = $randomStr . time() . "_" . $fileNameWithoutExtension . "." . $fileType;
                $target_path = $target_dir . $newFileName;

                // Move the uploaded file
                if (move_uploaded_file($temp_path, $target_path)) {
                    // Append full path to array
                    array_push($all_path, base_url() . $target_path);
                } else {
                    // Handle move_uploaded_file failure
                    echo json_encode(
                        array(
                            'status' => 500,
                            'message' => 'فشل في نقل الملف: ' . $filename,
                            'isAuth' => true,
                            'action' => false
                        ),
                        JSON_UNESCAPED_UNICODE
                    );
                    return;
                }
            }

            // Handle success
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'تم رفع الملفات بنجاح',
                    'isAuth' => true,
                    'data' => $all_path,
                    'action' => true
                ),
                JSON_UNESCAPED_UNICODE
            );
        } else {
            // Handle missing file error
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء رفع الملفات',
                    'isAuth' => true
                ),
                JSON_UNESCAPED_UNICODE
            );
        }
    }


    public function scanner_file($message)
    {
        $curl = curl_init();

        $post_fields = [
            "key" => "rN9yNrQ7AUNys9mEsi0YLYuLIsaVSmJJvGzl7PMA",
            //Demo key,  get yours at https://piesocket.com
            "secret" => "hcRnzwTKoBLGri6AJS7TQLXVT65GChiY",
            //Demo secret, get yours at https://piesocket.com
            "roomId" => "3213",
            "message" => ["text" => $message]
        ];
        curl_setopt_array(
            $curl,
            array(
                CURLOPT_URL => "https://s9272.fra1.piesocket.com/api/publish",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => json_encode($post_fields),
                CURLOPT_HTTPHEADER => array(
                    "Content-Type: application/json"
                ),
            )
        );

        $response = curl_exec($curl);
        return $response;
    }
}