<?php
require __DIR__ . '/jwt/autoload.php';
// require __DIR__ . '/vendor/autoload.php';

use Firebase\JWT\JWT;
use Firebase\JWT\Key;

// fire base from vender google firebase

class JwtMiddleware
{

    private $secret_key;

    public function __construct()
    {
        $this->secret_key = '@@redhaalasd2020@@';
        // load model
        $this->CI = &get_instance();
        $this->CI->load->model('NotificationModel');
        $this->CI->load->model('UserModel');

    }


    public function genereate_token_document($doc)
    {

        $doc_secret_key = "your-256-bit-secret";
        return JWT::encode($doc, $doc_secret_key, 'HS256');
    }

    public function encode($data, $expir = "11900")
    {
        $iat = time();
        $exp = $iat + $expir;
        $data["iat"] = $iat;
        $data["exp"] = $exp;
        $payload = $data;
        $jwt = JWT::encode($payload, $this->secret_key, 'HS256');
        return $jwt;
    }

    public function decode($token, $type = "normal")
    {
        try {
            $decoded = JWT::decode($token, new Key($this->secret_key, 'HS256'));
            $decoded_array = (array) $decoded;
            $exp = $decoded_array["exp"];
            $iat = time();
            if ($exp > $iat || $type == "logout") {
                return $decoded_array;
            } else {
                return 0;
            }

        } catch (Exception $e) {
            return 0;
        }
    }

    public function createHash()
    {
        try {
            // Get the current timestamp in microseconds
            $microtime = microtime(true);
            $timestamp = (int) ($microtime * 1000000);

            // Extract the last 7 digits to ensure a 7-digit number
            $hash = substr($timestamp, -7);

            return $hash;
        } catch (Exception $error) {
            error_log('createHash error: ' . $error->getMessage());
            return null;
        }
    }

    public function get_current_user_hash()
    {
        $headers = apache_request_headers();
        if (isset($headers['Authorization'])) {
            $authHeader = $headers['Authorization'];
            list($jwt) = sscanf($authHeader, 'Bearer %s');

            if ($jwt) {
                try {
                    $decoded = JWT::decode($jwt, new Key($this->secret_key, 'HS256'));
                    return $decoded->hash;
                } catch (Exception $e) {
                    return false;
                }
            }
        }

        return false;
    }

    public function sendNot($title, $data, $token, $body)
    {
        // Decode the JSON-encoded $data to an associative array
        $decodedData = json_decode($data, true);

        $decodedData = array_map('strval', $decodedData);
        // Prepare the message array with the decoded data
        $message = [
            'token' => $token, // Pass the dynamic token from parameter
            'notification' => [
                'title' => $title,
                'body' => $body,
            ],
            'data' => $decodedData, // Use the decoded data here
            'android' => [
                'priority' => 'high',
                'notification' => [
                    'sound' => 'default',
                ],
            ],
        ];

        // Get the access token
        $accessToken = $this->getAccessToken();

        // Define your Firebase project ID
        $projectId = 'zone-hr'; // Replace with your actual Firebase project ID
        $url = 'https://fcm.googleapis.com/v1/projects/' . $projectId . '/messages:send';

        // Set up the headers
        $headers = [
            'Authorization: Bearer ' . $accessToken, // Corrected "Bearer" format
            'Content-Type: application/json',
        ];

        // Initialize cURL
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode(['message' => $message]));

        // Execute the cURL request
        $response = curl_exec($ch);
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        // Check for cURL errors
        if ($response === false) {
            throw new Exception('Curl error: ' . curl_error($ch));
        }

        // Check if Firebase returned an error response
        if ($httpCode !== 200) {
            curl_close($ch);
            return ['error' => 'Firebase error: ' . $response];
        }

        // Close the cURL session
        curl_close($ch);

        // Return the decoded Firebase response
        return json_decode($response, true);
    }

    private function getAccessToken()
    {
        $url = 'https://zone.native-code-iq.com:3000/get-accesstoken/token';

        $ch = curl_init();

        // Set the cURL options
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            'Content-Type: application/json',
        ]);

        // Execute the cURL request
        $response = curl_exec($ch);

        // Check for cURL errors
        if (curl_errno($ch)) {
            throw new Exception('cURL error: ' . curl_error($ch));
        }

        // Close the cURL session
        curl_close($ch);

        // Decode the JSON response
        $data = json_decode($response, true);

        // Check if the access token is present in the response
        if (isset($data['access_token'])) {
            return $data['access_token'];
        } else {
            throw new Exception('Access token not found in the response');
        }
    }

    public function sendToMapNot()
    {
        $accessToken = $this->getAccessToken();
        $curl = curl_init();
        curl_setopt_array(
            $curl,
            array(
                CURLOPT_URL => "https://fcm.googleapis.com/v1/projects/zone-hr/messages:send",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => json_encode([
                    "message" => [
                        "topic" => "test",

                        "android" => [
                            "priority" => "high",
                        ],
                        "apns" => [
                            "payload" => [
                                "aps" => [
                                    "content-available" => 1,
                                ],
                            ],
                            "headers" => [
                                "apns-priority" => "10",
                            ],
                        ],
                    ],
                ]),
                CURLOPT_HTTPHEADER => array(
                    "Authorization: Bearer $accessToken",
                    "Content-Type: application/json",
                ),
            )
        );
        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
            echo "cURL Error #:" . $err;
        } else {
            echo $response;
        }
    }

    public function insertNotToFirebase($data)
    {
        $type = $data["type"];
        $user_hash = $data["user"];
        $user_name = $this->CI->UserModel->getUserName($user_hash);
        $title = "";
        $text = "";
        switch ($type) {
            case 'task':
                $receiver = $data["receiver"];
                $receiver_name = $this->CI->UserModel->getUserName($receiver);
                $status = $data["status"];
                switch ($status) {
                    case 'create':
                        $title = "واجب جديد";
                        $text = "قام $user_name باسناد واجب جديد الى $receiver_name";
                        break;
                    case 'status':
                        $status_title = $data["status_title"];
                        $title = "تغير حالة واجب";
                        if ($receiver_name == $user_name) {
                            $text = "قام $user_name بتغير حالة الواجب الخاص به الى $status_title";
                        } else {
                            $text = "قام $user_name بتغير حالة الواجب الخاص ب $receiver_name الى $status_title";
                        }
                        break;
                    case 'resend': // New case for "اعاده ارسال"
                        $title = "إعادة إرسال واجب";
                        $text = "قام $user_name بإعادة إرسال الواجب إلى $receiver_name";
                        break;
                    case 'emergency':
                        $emergency = $data["emergency"];
                        if ($emergency == "1") {
                            $title = "واجب ذو اولوية";
                            $text = "قام $user_name بتحويل الواجب الخاص ب $receiver_name الى واجب ذو اولوية";
                        } else {
                            $title = "واجب غير مستعجل";
                            $text = "قام $user_name بتحويل الواجب الخاص ب $receiver_name الى واجب غير مستعجل";
                        }
                    case 'accept':
                        $isaccept = $data["isaccept"];
                        if ($isaccept == "1") {
                            $title = "قبول واجب";
                            $text = "قام $user_name بقبول الواجب الخاص ب $receiver_name";
                        } else {
                            $title = "رفض واجب";
                            $text = "قام $user_name برفض الواجب الخاص ب $receiver_name";
                        }
                        break;
                    case 'receiver':
                        $title = "تغير مسؤول الواجب";
                        $text = "قام $user_name بتغير مسؤول الواجب الخاص به الى $receiver_name";
                        break;
                    default:
                        // code...
                        break;
                }
                break;
            case 'fingerPrint':
                $status = $data["status"];
                $title = "تسجيل بصمة";
                if ($status == "in") {
                    $text = "قام $user_name بعمل بصمة دخول";
                } else {
                    $text = "قام $user_name بعمل بصمة خروج";
                }

                break;
            case 'check_in':
                $title = "تسجيل موقع";
                $note = $data["note"];
                $text = "قام $user_name بتسجيل موقعه بملاحظة $note";
                break;
            case 'vacation':
                $status = $data["status"];
                $receiver = $data["receiver"];
                $receiver_name = $this->CI->UserModel->getUserName($receiver);
                switch ($status) {
                    case 'request':
                        $title = "طلب اجازه";
                        $text = "قام $user_name بطلب اجازه من $receiver_name";
                        break;
                    case '111':
                        $title = "تمت الموافقة علي اجازة";
                        $text = "تمت الموافقة علي اجازة $receiver_name من قبل $user_name";
                        break;
                    case '222':
                        $title = "تم رفض اجازة";
                        $text = "تم رفض اجازة $receiver_name من قبل $user_name";
                        break;
                    case '333':
                        $title = "تم تمرير اجازة";
                        $text = "تم تمرير اجازة الي $receiver_name من قبل $user_name";
                        break;
                    default:
                        break;
                }
                break;
            case 'advance':
                $status = $data["status"];
                $receiver = $data["receiver"];
                $receiver_name = $this->CI->UserModel->getUserName($receiver);
                switch ($status) {
                    case 'request':
                        $title = "طلب سلفه";
                        $text = "قام $user_name بطلب سلفه من $receiver_name";
                        break;
                    case '1':
                        $title = "تمت الموافقة على سلفة";
                        $text = "تمت الموافقة على سلفة $receiver_name من قبل $user_name";
                        break;
                    case '2':
                        $title = "تم رفض سلفة";
                        $text = "تم رفض سلفة $receiver_name من قبل $user_name";
                        break;
                    case '3':
                        $title = "تم تمرير سلفة";
                        $text = "تم تمرير سلفة الى $receiver_name من قبل $user_name";
                        break;
                    default:
                        break;
                }
                break;
            case 'suggestion':
                $status = $data["status"];
                $receiver = $data["receiver"];
                $receiver_name = $this->CI->UserModel->getUserName($receiver);
                switch ($status) {
                    case 'create':
                        $title = "اقتراح جديد";
                        $text = "تم إنشاء اقتراح جديد من قبل $user_name";
                        break;
                }
                break;
            case 'not_connected':
                $message = $data["message"];
                $receiver = $data["receiver"];
                $receiver_name = $this->CI->UserModel->getUserName($receiver);

                $title = "غير متصل بالتطبيق";
                $text = "قام $user_name ارسال الى $receiver_name  $message";
                // $text = $message ;
                break;
            default:
                # code...
                break;
        }
        $curl = curl_init();
        if ($text != "" && $title != "") {

            $this->CI->NotificationModel->createNotification($title, $type, $text, $user_hash);

            $post_fields = [
                "key" => "rN9yNrQ7AUNys9mEsi0YLYuLIsaVSmJJvGzl7PMA",
                "secret" => "hcRnzwTKoBLGri6AJS7TQLXVT65GChiY",
                "roomId" => 'spaceLight',
                "message" => ["type" => $type, "withSound" => true],
            ];

            curl_setopt_array(
                $curl,
                array(
                    CURLOPT_URL => "https://s9272.fra1.piesocket.com/api/publish",
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_CUSTOMREQUEST => "POST",
                    CURLOPT_POSTFIELDS => json_encode($post_fields),
                    CURLOPT_HTTPHEADER => array(
                        "Content-Type: application/json",
                    ),
                )
            );

            $response = curl_exec($curl);
            return $response;
        } else {
            return 0;
        }

    }

    public function insertMutedNotification()
    {
        $curl = curl_init();

        $post_fields = [
            "key" => "rN9yNrQ7AUNys9mEsi0YLYuLIsaVSmJJvGzl7PMA",
            "secret" => "hcRnzwTKoBLGri6AJS7TQLXVT65GChiY",
            "roomId" => 'spaceLight',
            "message" => ["type" => "mutedNot", "withSound" => false],
        ];

        curl_setopt_array(
            $curl,
            array(
                CURLOPT_URL => "https://s9272.fra1.piesocket.com/api/publish",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => json_encode($post_fields),
                CURLOPT_HTTPHEADER => array(
                    "Content-Type: application/json",
                ),
            )
        );

        $response = curl_exec($curl);
        return $response;
    }

    public function sendWhatsMessageForMultiUsers($data)
    {
        $instanceId = '102666';
        $token = 'mts08asbj5oo4tvx';
        $url = 'https://api.ultramsg.com/instance' . $instanceId . '/messages/chat';

        $recipients = $data["numbers"];
        $body = $data["body"];
        // Validate $recipients
        if (!is_array($recipients) || empty($recipients)) {
            throw new InvalidArgumentException("Recipients must be a non-empty array.");
        }

        // Check if all elements in the $recipients array are valid numbers
        foreach ($recipients as $recipient) {
            if (!is_numeric($recipient)) {
                throw new InvalidArgumentException("All recipients must be valid numbers.");
            }
        }

        // Validate $body
        if (!is_string($body) || empty(trim($body))) {
            throw new InvalidArgumentException("Body must be a non-empty string.");
        }

        foreach ($recipients as $recipient) {

            $params = array(
                'token' => $token,
                'to' => $recipient,
                'body' => $body
            );

            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => http_build_query($params),
                CURLOPT_HTTPHEADER => array(
                    "content-type: application/x-www-form-urlencoded"
                ),
            ));

            $response = curl_exec($curl);
            $err = curl_error($curl);

            curl_close($curl);

            if ($err) {
                echo "cURL Error #:" . $err;
            } else {
                return $response;
            }
        }
    }
    public function sendSMSNot($token, $title, $body, $phone, $message)
    {
        $message = [
            'token' => $token,
            'notification' => [
                'title' => $title,
                'body' => $body,
            ],
            'data' => [
                'phone' => $phone,
                'message' => $message
            ],
            'android' => [
                'priority' => 'high',
                'notification' => [
                    'sound' => 'default',
                ],
            ],
        ];

        // Get the access token
        $accessToken = $this->getSMSAccessToken();

        // Define your Firebase project ID
        $projectId = 'sms-sender-dadce'; // Replace with your actual Firebase project ID
        $url = 'https://fcm.googleapis.com/v1/projects/' . $projectId . '/messages:send';

        // Set up the headers
        $headers = [
            'Authorization: Bearer ' . $accessToken, // Corrected "Bearer" format
            'Content-Type: application/json',
        ];

        // Initialize cURL
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode(['message' => $message]));

        // Execute the cURL request
        $response = curl_exec($ch);
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        // Check for cURL errors
        if ($response === false) {
            throw new Exception('Curl error: ' . curl_error($ch));
        }

        // Check if Firebase returned an error response
        if ($httpCode !== 200) {
            curl_close($ch);
            return ['error' => 'Firebase error: ' . $response];
        }

        // Close the cURL session
        curl_close($ch);

        // Return the decoded Firebase response
        return ['response' => json_decode($response, true), 'status' => $httpCode];
    }

    private function getSMSAccessToken()
    {
        $url = 'https://zone.native-code-iq.com:3000/get-accesstoken/token/sms';

        $ch = curl_init();

        // Set the cURL options
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            'Content-Type: application/json',
        ]);

        // Execute the cURL request
        $response = curl_exec($ch);

        // Check for cURL errors
        if (curl_errno($ch)) {
            throw new Exception('cURL error: ' . curl_error($ch));
        }

        // Close the cURL session
        curl_close($ch);

        // Decode the JSON response
        $data = json_decode($response, true);

        // Check if the access token is present in the response
        if (isset($data['access_token'])) {
            return $data['access_token'];
        } else {
            throw new Exception('Access token not found in the response');
        }
    }

}
