<?php

class TokenMiddleware
{
    public function __construct()
    {
        $this->CI = &get_instance();
        $this->CI->load->model('UserModel');
        $this->CI->load->library('JwtMiddleware');

    }

    public function getBearerToken()
    {
        $headers = apache_request_headers();
        $authorization = $headers['Authorization'] ?? $headers['authorization'] ?? null;
        if (isset($authorization)) {
            if (preg_match('/Bearer\s(\S+)/', $authorization, $matches)) {
                return $matches[1];
            }
        }
        return 0;
    }

    public function checkToken($token)
    {
        if ($token) {
            $jwt = new JwtMiddleware(); // Ensure JwtMiddleware class exists and is included
            $decoded = $jwt->decode($token);
            if ($decoded) {
                return $decoded;
            } else {
                return 0;
            }
        } else {
            return 0;
        }
    }

    public function main()
    {
        // Load necessary libraries and models
        // $this->load->library('JwtMiddleware');
        // $this->load->model('UserModel');

        $jwt = new JwtMiddleware(); // Ensure JwtMiddleware class exists and is included

        // Get token from header
        $token = $this->getBearerToken();

        // Check token
        if (!$this->checkToken($token)) {
            echo json_encode(
                array(
                    "status" => 401,
                    "message" => "يجب تسجيل الدخول للوصول لهذه الصفحة",
                    "isAuth" => false,
                    "data" => null,
                    "token" => null,
                )
            );
            exit();
        }

        // Decode the token
        $tokenData = $jwt->decode($token);
        $user_hash = $tokenData['hash'];

        // Check if user_hash is deleted or user credentials are invalid
        if ($this->CI->UserModel->isUserHashDeleted($user_hash) || !$this->CI->UserModel->getUser($tokenData['username'], $tokenData['password'])) {
            echo json_encode(
                array(
                    "status" => 401,
                    "message" => "الحساب غير موجود أو تم حذفه",
                    "isAuth" => false,
                    "data" => null,
                    "token" => null,
                )
            );
            exit();
        }

        // If token is valid, update token
        $newToken = $jwt->encode($tokenData);
        return $newToken;
    }
}
