<?php

class ArchievePayrollModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->library('Middleware');
    }

    // this get from table emp_payroll by grouped hash , created_at , approved
    // we need to get grouped by hash then we need get data by this hash



    public function getGroupedArcheievedPayrollByHash( $from , $to ,$page = 1, $perPage = 10 , $searchTerm = '') {
        $offset = ($page - 1) * $perPage;


        $this->db->select('hash, created_at,from ,to, year_months')
            ->from('emp_payroll')
            ->where("from <= '$to' AND to >= '$from'")
            ->where('approved', 1);

        if (!empty($searchTerm)) {

            $this->db->like('hash', $searchTerm); // Replace 'column_name' with the actual column to search
        }

        $this->db->group_by('hash')->limit($perPage, $offset);

        $query = $this->db->get();

        $count = $query->num_rows();

        return [
            'count' => $count,
            'data' => $count > 0 ? $query->result_array() : [],
            'status' => $count > 0 ? 200 : 404,
        ];
    }

    public function getArchivedPayroll($hash, $page = 1, $perPage = 10, $searchTerm = '') {
        $offset = ($page - 1) * $perPage;

        $this->db->select('emp_payroll.*, emp_payroll.emp_name as name, system_users.image_profile');
        $this->db->select('(select IBN from emp_information WHERE system_users.hash = emp_information.user_hash) AS IBN');
        $this->db->from('emp_payroll');
        $this->db->join('system_users', 'system_users.hash = emp_payroll.emp_id');
        $this->db->where('emp_payroll.hash', $hash);
        $this->db->where('emp_payroll.approved', 1);

        //        $this->db->select("system_users.image_profile")->from('system_users')->where('system_users.hash', 'emp_payroll.emp_id');

        if (!empty($searchTerm)) {
            $this->db->like('emp_name', $searchTerm);
        }

        $this->db->limit($perPage, $offset);

        $query = $this->db->get();
        $count = $query->num_rows();

        return [
            'count' => $count,
            'data' => $count > 0 ? $query->result_array() : [],
            'status' => $count > 0 ? 200 : 404,
        ];
    }



}