<?php
class BankModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    // get all Groups
    public function count_records()
    {
        $headers = apache_request_headers();
        $search = $this->input->get('q') ?? '';
        $this->db->select('count(*) as count');
        $this->db->from('bank');
        if ($search) {
            $this->db->like('name', $search);
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    public function getAllBanks()
    {
        // get page and limit and search from header
        $headers = apache_request_headers();
//        $page = $headers['page'] ?? $this->input->get('page') ?? 1;
//        $perPage = $headers['perPage'] ?? $this->input->get('perPage') ?? 10;
//        $search = $this->input->get('q') ?? '';
//        $offset = ($page - 1) * $perPage;

        $this->db->select(
            'bank.*, currency.name AS currency_name'
        );
        $this->db->from('bank');
        $this->db->join('currency', 'currency.id = bank.currency');

        // search
//        if ($search) {
//            $this->db->like('account_name', $search);
//        }

        // order by
        $this->db->order_by('id', 'DESC');
        // limit
//        $this->db->limit($perPage, $offset);
        $query = $this->db->get();

        return $query->result_array();
    }
    public function getAll_select()
    {
        $headers = apache_request_headers();
        $this->db->select('name AS label, hash AS value');
        $this->db->from('bank');
        $this->db->order_by('id', 'DESC');
        $query = $this->db->get();
        return $query->result_array();
    }

    function getBank($hash)
    {
        $this->db->select('bank.*, currency.name AS currency_name');
        $this->db->from('bank');
        $this->db->join('currency', 'currency.id = bank.currency');
        $this->db->where('bank.hash =', $hash);
        $query = $this->db->get();

        $result = $query->result_array();
        return $result;
    }

    function createBank($data)
    {
        $this->db->insert('bank', $data);
        $bank_id =  $this->db->insert_id();
        $accounting_tree_id = '11125' . $bank_id;
        $accounting_hash = $this->jwtmiddleware->createHash();
        $accounting_tree_data = array(
            'number' => $accounting_tree_id,
            'name' => $data['name'],
            'hash'=> $accounting_hash
        );
        $this->db->insert('accounting_tree', $accounting_tree_data);
        return $this->db->insert_id();
    }

    function updateBank($data)
    {
        $this->db->where('hash', $data['hash']);
        $this->db->update('bank', $data);
        return $this->db->affected_rows();
    }

    function deleteBank($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('bank');
        return $this->db->affected_rows();
    }
}
