<?php
class EmpCalcWorkedHoursConfigModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    public function getConfiguration()
    {
        $this->db->select('*')->from('emp_worked_hours_flags');
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getMainConfig()
    {
        $this->db->select('*')->from('emp_worked_hours_flags')->where('is_main', '1');
        $query = $this->db->get();
        return $query->row();
    }
    public function addConfiguration($data)
    {
        $this->db->insert('emp_worked_hours_flags', $data);
        return $this->db->affected_rows();

    }

    public function getConfigurationById($id)
    {

        $this->db->select('*')->from('emp_worked_hours_flags')->where('id', $id);
        $query = $this->db->get();
        return $query->row();
    }
    public function editConfigration($id, $configurationData)
    {

        $this->db->where('id', $id);
        $this->db->update('emp_worked_hours_flags', $configurationData);
        return $this->db->affected_rows();

    }

    public function deleteConfiguration($id)
    {
        // Check if the is_main column is 1
        $this->db->select('is_main');
        $this->db->from('emp_worked_hours_flags');
        $this->db->where('id', $id);
        $query = $this->db->get();
        $result = $query->row();

        if ($result && $result->is_main == '1') {
            return [
                'status' => 'error',
                'message' => 'لا يمكن حذف الكونفيج لأنه معتمد يساوي .',
            ];
        }

        // Proceed with deletion if is_main is not 1
        $this->db->where('id', $id);
        $this->db->delete('emp_worked_hours_flags');
        $affectedRows = $this->db->affected_rows();

        if ($affectedRows > 0) {
            return [
                'status' => 'success',
                'message' => 'تم حذف الكونفيج بنجاح.',
            ];
        } else {
            return [
                'status' => 'error',
                'message' => 'لم يتم العثور على تكوين بالمعرف المحدد.',
            ];
        }
    }

    public function makeConfigIsTheMain($id)
    {
        // Check if the specified row already has is_main = 1
        $this->db->select('is_main');
        $this->db->from('emp_worked_hours_flags');
        $this->db->where('id', $id);
        $query = $this->db->get();
        $result = $query->row();

        if ($result && $result->is_main == '1') {
            return [
                'status' => 'info',
                'message' => 'الكونفيج المحدد هو بالفعل الكونفيج المعتمد.',
            ];
        }

        // Start transaction
        $this->db->trans_start();

        // Set all rows to is_main = 0
        $this->db->where('is_main', '1');
        $this->db->update('emp_worked_hours_flags', ['is_main' => 0]);

        // Set the specified row to is_main = 1
        $this->db->where('id', $id);
        $this->db->update('emp_worked_hours_flags', ['is_main' => 1]);

        // Complete the transaction
        $this->db->trans_complete();

        // Check if the transaction was successful
        if ($this->db->trans_status() === false) {
            return [
                'status' => 'error',
                'message' => 'فشل في تحديث الكونفيج الى معتمد.',
            ];
        } else {
            return [
                'status' => 'success',
                'message' => 'تم تحديث الكونفيج إلى معتمد بنجاح.',
            ];
        }
    }

    public function recalcEmployeesWorkedHours($data, $employees)
    {

    }

}
