<?php
class FinanceModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    // إضافة عميل
    public function add($data)
    {
        $this->db->insert('finance_table', $data);
        return $this->db->insert_id();
    }

    // تحديث عميل
    public function update($hash, $data)
    {
        $this->db->where('id', $hash);
        $this->db->update('finance_table', $data);
        return $this->db->affected_rows();
    }

    // حذف عميل
    public function delete($hash)
    {
        $this->db->where('id', $hash);
        $this->db->delete('finance_table');
        return $this->db->affected_rows();
    }

    // استرداد عميل بالهاش
    public function get($hash)
    {
        $query = $this->db->get_where('finance_table', array('id' => $hash));
        return $query->row_array();
    }

    // استرداد كل المشاريع
    public function get_all($page = 1, $perpage = 10, $search = '')
    {
        $offset = ($page - 1) * $perpage;

        $this->db->select('*');
        $this->db->from('finance_table');

        if ($search != '') {
            // decode the search
            $search = urldecode($search);
            $this->db->like('name', $search);
        }

        $this->db->limit($perpage, $offset);

        $query = $this->db->get();
        return $query->result_array();
    }


    public function count_records($search = '')
    {
        $this->db->select('count(*) as count');
        $this->db->from('finance_table');
        if ($search != '') {
            // decode the search
            $search = urldecode($search);
            $this->db->like('name', $search);
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }
}
