<?php

class PenatlyCalculationModel extends CI_MODEL
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    public function getPenatlyCalc($user_hash, $date)
    {
        $this->db->select("*")->from("users_penatly")->where("user_hash", $user_hash)->where("date", $date);
        $result = $this->db->get();
        if ($result->num_rows() > 0) {
            return $result->row();
        } else {
            return [];
        }
    }

    public function checkIsEmpAbsence($user_hash, $date)
    {
        $this->db->select("*")->from("employee_absences")->where("user_hash", $user_hash)->where("date", $date);
        $result = $this->db->get();
        if ($result->num_rows() > 0) {
            return true;
        }

        return false;
    }

    public function getDataToSendGPT($user_hash, $date)
    {
        $sql = "
        SELECT
            JSON_OBJECT(
                'user_hash', ei.user_hash,
		        'schedule_for_day', asch.schedule_data,
                'allowance_time', asch.allowance_time,
                'in_fingerprint_time', CONCAT('[', GROUP_CONCAT(CASE WHEN ef.in_out = 'in' THEN CONCAT('\"', DATE_FORMAT(ef.fingerprint_time, '%Y-%m-%d %H:%i:%s'), '\"') END ORDER BY ef.fingerprint_time SEPARATOR ','), ']'),
                'out_fingerprint_time', CONCAT('[', GROUP_CONCAT(CASE WHEN ef.in_out = 'out' THEN CONCAT('\"', DATE_FORMAT(ef.fingerprint_time, '%Y-%m-%d %H:%i:%s'), '\"') END ORDER BY ef.fingerprint_time DESC SEPARATOR ','), ']'),
                'date', '$date',
                'isVacation', CASE WHEN MIN(v.id) IS NOT NULL THEN 'true' ELSE 'false' END
            ) AS employee_data
        FROM
            emp_information ei
        JOIN
            actual_schedules asch ON ei.user_hash = asch.user_hash
            AND asch.date = '$date'
        LEFT JOIN
            emp_fingerprint ef ON ei.user_hash = ef.user_hash
            AND DATE(ef.fingerprint_time) = '$date'
        LEFT JOIN
            vacations v ON v.user_hash = ei.user_hash
            AND v.status = '111'
            AND DATE(v.date_start) = '$date'
        LEFT JOIN
            vacations_type vt ON vt.hash = v.vication_type_hash
        WHERE
            ei.user_hash = '$user_hash'
        GROUP BY
            ei.user_hash;
        ";
        $query = $this->db->query($sql);

        if ($query->num_rows() > 0) {
            return $query->row();
        } else {
            return [];
        }
    }

    public function savePenatlyCalc($user_hash, $date, $data, $result)
    {
        $userPenatlyData = [
            "user_hash" => $user_hash,
            "date" => $date,
            "shifts" => json_encode($data['schedule_for_day']),
            "total_penalty" => $result['totalPenaltyMinutes'],
            'total_missing_hours' => $result['totalMissedHours'],
            'total_hours_worked' => $result['totalWorkedHours'],
            'totalLateArrivalMinutes' => $result['totalLateArrivalMinutes'],
            'totalEarlyDepartureMinutes' => $result['totalEarlyDepartureMinutes']
        ];
        $this->db->insert("users_penatly", $userPenatlyData);

        return $this->db->insert_id();
    }
}
