<?php

class PermissionModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    public function getPermissions($group_hash)
    {
        $this->db->select(' 
            group_hash,table_name,name,select_op,update_op,
            insert_op,delete_op
        ');
        $this->db->from('system_privilage_role');
        $this->db->join('system_group_name', 'system_privilage_role.group_hash = system_group_name.hash', 'inner');
        $this->db->where('group_hash', $group_hash);
        $query = $this->db->get();
        $results = $query->result();
        return $results;
    }

    public function createPermission($data)
    {
        $this->db->insert('system_privilage_role', $data);
        return  $this->db->affected_rows();
    }

    public function updatePermission($data)
    {
        $this->db->where('hash', $data['hash']);
        $this->db->update('system_privilage_role', $data);
        return  $this->db->affected_rows();
    }

    public function deletePermission($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('system_privilage_role');
        return  $this->db->affected_rows();
    }
}
