<?php
class SupplierModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->library('Middleware');
    }

    public function add($data)
    {
        $this->db->insert('supplier', $data);
        $supplier_id =  $this->db->insert_id();
        $accounting_tree_id = '11125' . $supplier_id;
        $accounting_hash = $this->jwtmiddleware->createHash();
        $accounting_tree_data = array(
            'number' => $accounting_tree_id,
            'name' => $data['name'],
            'hash'=> $accounting_hash
        );
        $this->db->insert('accounting_tree', $accounting_tree_data);
        return $this->db->insert_id();
    }

    // تحديث عميل
    public function update($hash, $data)
    {
        $this->db->where('hash', $hash);
        $this->db->update('supplier', $data);
        return $this->db->affected_rows();
    }

    // حذف عميل
    public function delete($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('supplier');
        return $this->db->affected_rows();
    }

    public function get($hash)
    {
        $query = $this->db->get_where('supplier', array('hash' => $hash));
        return $query->row_array();
    }

    // استرداد كل المشاريع
    public function get_all($page = 1, $perpage = 10, $search = '')
    {
        $offset = ($page - 1) * $perpage;

        $this->db->select('*');
        $this->db->from('supplier');

        if ($search != '') {
            // decode search value
            $search = urldecode($search);
            $this->db->like('name', $search);

        }

        $this->db->limit($perpage, $offset);
        // order by id desc
        $this->db->order_by('id', 'DESC');
        $query = $this->db->get();
        return $query->result_array();
    }


    public function count_records($search = '')
    {
        $this->db->select('count(*) as count');
        $this->db->from('supplier');
        if ($search != '') {
            // decode search value
            $search = urldecode($search);
            $this->db->like('name', $search);
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }
}