<?php
class TodayReportsModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->page = $this->input->get('page') ?? 1;
        $this->perPage = $this->input->get('perPage') ?? 10;
        $this->offset = ($this->page - 1) * $this->perPage;
        $this->search = $this->input->get('q') ?? '';
    }

    public function tasks()
    {
        $this->db->select("
            title, discription,deadline,score,acceptnote,updated_at,
            (SELECT name FROM system_users WHERE hash = task.receiver) as receiver_user,
            (SELECT name FROM system_users WHERE hash = task.sender) as sender_user,
            (select title from task_status where hash = task.status) as status_title,
            isaccept,status,hash,sender,receiver,project_hash,emergency
        ");
        $this->db->from('task');
        // where today between start_task and deadline
        $this->db->where("start_task <= '" . date('Y-m-d') . "' and deadline >= '" . date('Y-m-d') . "'");
        $this->db->limit($this->perPage, $this->offset);
        $this->db->order_by('id', 'desc');
        $query = $this->db->get();
        $result = $query->result();
        $countQuery = $this->db->query("select count(*) as count from task where start_task <= curdate() and deadline >= curdate()");
        $count = $countQuery->result()[0]->count;
        return array(
            'data' => $result,
            'total' => $count
        );
    }

    public function vacations()
    {
        $this->db->select("name, image_profile, DATE(date_start) AS date_s, date_start, date_end,
            TIME_FORMAT(TIME(date_start), '%l:%i %p') AS time_start, vication_type_hash, 
            DATE(date_end) AS date_e, TIME_FORMAT(TIME(date_end), '%l:%i %p') AS time_end, 
            vacations.hash AS hash, vacations.note AS note, vacations.user_hash, 
            (select Name from Positions where Positions.ID=emp_information.position) as position,
            (SELECT type FROM vacations_type WHERE vacations_type.hash = vacations.vication_type_hash) AS type, 
            (SELECT title FROM vacations_status WHERE vacations_status.hash = vacations.status) AS status_title, 
            (SELECT name FROM partments WHERE emp_information.partment = partments.hash) AS department, 
            (SELECT name FROM system_group_name WHERE hash = (SELECT user_type FROM system_users WHERE hash = vacations.user_hash)) AS job");
        $this->db->from('vacations');
        $this->db->join('system_users', 'vacations.user_hash = system_users.hash', 'left');
        $this->db->join('emp_information', 'vacations.user_hash = emp_information.user_hash', 'left');
        // today between date_start and date_end
        $this->db->where("date(date_start) <= '" . date('Y-m-d') . "' and date(date_end) >= '" . date('Y-m-d') . "'");
        $this->db->where('vacations.admin IS NOT NULL');
        $this->db->where('vacations.hash IS NOT NULL');     
        $this->db->order_by('partment');
        $query = $this->db->get();
        $result = $query->result();
        $countQuery = $this->db->query("select count(*) as count from vacations where date(date_start) <= '" . date('Y-m-d') . "' and date(date_end) >= '" . date('Y-m-d') . "' and vacations.hash IS NOT NULL and vacations.admin IS NOT NULL");
        $count = $countQuery->result()[0]->count;
        return array(
            'data' => $result,
            'total' => $count
        );
    }
}