<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Zk_devicesModel extends CI_Model
{
    protected $table = 'zk_devices';

    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    public function create($data)
    {
        $this->db->insert($this->table, $data);
        return $this->db->insert_id();
    }

    public function getAll()
    {
        $sql = "
    SELECT 
        zk_devices.*,
        CASE 
            WHEN zk_fingerprints_log.id IS NULL AND zk_queue.id IS NULL 
            THEN '1'
            ELSE '0'
        END AS can_delete
    FROM zk_devices
    LEFT JOIN zk_fingerprints_log 
        ON SUBSTRING_INDEX(zk_fingerprints_log.device_info, ':', -1) = zk_devices.port
        AND SUBSTRING_INDEX(zk_fingerprints_log.device_info, ':', 1) = zk_devices.ip
    LEFT JOIN zk_queue 
        ON JSON_UNQUOTE(JSON_EXTRACT(zk_queue.task_data, '$.device_hash')) = zk_devices.id
        AND JSON_UNQUOTE(JSON_EXTRACT(zk_queue.task_data, '$.port')) = zk_devices.port
        AND JSON_UNQUOTE(JSON_EXTRACT(zk_queue.task_data, '$.ip')) = zk_devices.ip
    GROUP BY zk_devices.id
";

        $query = $this->db->query($sql);
        return $query->result_array();

    }

    public function getById($id)
    {
        return $this->db->get_where($this->table, ['id' => $id])->row_array();
    }

    public function update($id, $data)
    {
        $this->db->where('id', $id);
        $this->db->update($this->table, $data);
        return $this->db->affected_rows(); // Return the number of affected rows
    }

    public function delete($id)
    {
        $this->db->where('id', $id);
        $this->db->delete($this->table);
        return $this->db->affected_rows(); // Return the number of affected rows
    }
}